#version 330 core

layout (location = 0) in vec3 vertex;
layout (location = 1) in vec3 vertex_normal;
layout (location = 2) in vec3 colorRGB;


uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform vec3 lightPos;

out vec3 normal, lightDir;
out vec3 colorVS;
out vec3 viewDir;


void main(){

    gl_Position = projection * view * model *  vec4(vertex, 1.0);
    colorVS = colorRGB;

    // compute normal in view space //
    vec4 n = vec4(vertex_normal, 1.0);
    mat4 normalMat = transpose(inverse(view * model));
    normal = (normalMat * n).xyz;

    // compute light direction in view space //
    vec4 lp = vec4(view * vec4(lightPos, 1.0));
    vec4 P = view * model * vec4(vertex, 1.0);
    lightDir = (lp - P).xyz;

    // specular term //
    viewDir = -P.xyz;

}
